%global __cmake_in_source_build 1
%global debug_package %{nil}

Summary:       C++ bindings for libpmemobj
Name:          libpmemobj-cpp
Version:       1.13.0
Release:       4%{?dist}
License:       BSD
URL:           http://pmem.io/pmdk/cpp_obj/
Source0:       https://github.com/pmem/%{name}/archive/%{version}.tar.gz#/%{version}.tar.gz

Patch0001:     0001-Fix-compliation-on-gcc-12.patch


BuildRequires: libpmemobj-devel cmake glibc-devel gcc-c++
BuildRequires: pkgconfig perl-Encode gdb libatomic make
BuildRequires: ncurses-devel libunwind-devel valgrind-devel tbb-devel

ExclusiveArch: x86_64 ppc64le

%description
This package provides header files for libpmemobj C++ bindings and C++ containers built on top of them.

%package -n libpmemobj++-devel
Summary:    C++ bindings for Persistent Memory Transactional Object Store library
Requires:   libpmemobj-devel
Provides:   libpmemobj++-static = %{version}-%{release}

%description -n libpmemobj++-devel
This package provides header files for libpmemobj C++ bindings and C++ containers built on top of them.
The libpmemobj library provides a transactional object store, providing memory allocation, transactions,
and general facilities for persistent memory programming.

%prep
%autosetup -n %{name}-%{version} -p1
mkdir build

%build
cd build
%cmake .. \
    -DCMAKE_INSTALL_DOCDIR=%{_docdir}/libpmemobj++ \
    -DTESTS_USE_FORCED_PMEM=ON \
    -DCXX_STANDARD=17
%make_build

%install
cd build
%make_install
rm -rf %{buildroot}%{_docdir}/libpmemobj++/*

%check
cd build
ctest -V -E 'concurrent_hash_map_rehash_0_helgrind|concurrent_hash_map_insert_lookup_0_helgrind|enumerable_thread_specific_access_0_drd|inline_string_0_memcheck|radix_tx_abort_0_memcheck|concurrent_hash_map_layout_0_none|segment_vector_.*|mpsc_.*|concurrent_hash_map_rehash_break_.*'

%files -n libpmemobj++-devel
%license LICENSE
%doc ChangeLog README.md
%{_libdir}/pkgconfig/libpmemobj++.pc
%dir %{_includedir}/libpmemobj++
%{_includedir}/libpmemobj++/*.hpp
%dir %{_includedir}/libpmemobj++/detail
%{_includedir}/libpmemobj++/detail/*.hpp
%dir %{_includedir}/libpmemobj++/container
%{_includedir}/libpmemobj++/container/*.hpp
%dir %{_includedir}/libpmemobj++/container/detail
%{_includedir}/libpmemobj++/container/detail/*.hpp
%dir %{_includedir}/libpmemobj++/experimental
%{_includedir}/libpmemobj++/experimental/*.hpp
%dir %{_libdir}/libpmemobj++
%dir %{_libdir}/libpmemobj++/cmake
%{_libdir}/libpmemobj++/cmake/libpmemobj++-config-version.cmake
%{_libdir}/libpmemobj++/cmake/libpmemobj++-config.cmake

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.13.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.13.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.13.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 28 2022 Shuo Wang <abushwang@tencent.com> - 1.13.0-1
- initial build

